﻿<%@ Page Language="VB" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">
    Protected Sub grid_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim lbl As Label = DirectCast(grid.SelectedRow.FindControl("Label1"), Label)
        sds_d.SelectParameters("name").DefaultValue = lbl.Text
        mv.ActiveViewIndex = 1
    End Sub
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>MultiViewコントロール</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:MultiView ID="mv" runat="server" ActiveViewIndex="0">
            <asp:View ID="v1" runat="server">
                <asp:GridView ID="grid" runat="server" AllowPaging="True" AllowSorting="True"
                    AutoGenerateColumns="False" CellPadding="4" DataKeyNames="isbn" DataSourceID="sds"
                    ForeColor="#333333" GridLines="None" PageSize="3" OnSelectedIndexChanged="grid_SelectedIndexChanged">
                    <FooterStyle BackColor="#1C5E55" Font-Bold="True" ForeColor="White" />
                    <Columns>
                        <asp:ImageField DataAlternateTextField="title" DataAlternateTextFormatString="{0}"
                            DataImageUrlField="isbn" DataImageUrlFormatString="http://www.wings.msn.to/books/{0}/{0}_logo.jpg"
                            HeaderText="ロゴ">
                        </asp:ImageField>
                        <asp:HyperLinkField DataNavigateUrlFields="isbn" DataNavigateUrlFormatString="http://www.wings.msn.to/index.php/-/A-03/{0}/"
                            DataTextField="isbn" DataTextFormatString="ISBN{0}" HeaderText="ISBNコード" SortExpression="isbn"
                            Target="_blank" />
                        <asp:BoundField DataField="title" HeaderText="書名" SortExpression="title" />
                        <asp:TemplateField HeaderText="出版社" SortExpression="publish">
                            <EditItemTemplate>
                                <asp:DropDownList ID="ddlPublish" runat="server" DataSourceID="sdsPub" DataTextField="name"
                                    DataValueField="name" SelectedValue='<%# Bind("publish") %>'>
                                </asp:DropDownList><asp:SqlDataSource ID="sdsPub" runat="server" CacheDuration="6000"
                                    ConnectionString="<%$ ConnectionStrings:myDb %>" EnableCaching="True" SelectCommand="SELECT [name] FROM [publish]">
                                </asp:SqlDataSource>
                            </EditItemTemplate>
                            <ItemTemplate>
                                <asp:Label ID="Label1" runat="server" Text='<%# Bind("publish") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="単価" SortExpression="price">
                            <EditItemTemplate>
                                <asp:TextBox ID="txtPrice" runat="server" Columns="5" Text='<%# Bind("price") %>'></asp:TextBox>円<asp:RequiredFieldValidator
                                    ID="reqPrice" runat="server" ControlToValidate="txtPrice" Display="Dynamic" ErrorMessage="価格は必須です。"
                                    SetFocusOnError="True" ValidationGroup="grid">*</asp:RequiredFieldValidator><asp:RangeValidator
                                        ID="rngPrice" runat="server" ControlToValidate="txtPrice" Display="Dynamic" ErrorMessage="価格は0～100000円の間で入力してください。"
                                        MaximumValue="100000" MinimumValue="0" SetFocusOnError="True" Type="Integer"
                                        ValidationGroup="grid">*</asp:RangeValidator>
                            </EditItemTemplate>
                            <ItemTemplate>
                                <asp:Label ID="Label2" runat="server" Text='<%# Bind("price", "{0:#,###}円") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="刊行日" SortExpression="publishDate">
                            <EditItemTemplate>
                                <asp:TextBox ID="txtPublishDate" runat="server" Columns="12" Text='<%# Bind("publishDate","{0:yyyy/MM/dd}") %>'></asp:TextBox><asp:CompareValidator
                                    ID="cmpPublishDate" runat="server" ControlToValidate="txtPublishDate" Display="Dynamic"
                                    ErrorMessage="刊行日はYYYY/MM/DD形式で入力してください。" Operator="DataTypeCheck" SetFocusOnError="True"
                                    Type="Date" ValidationGroup="grid">*</asp:CompareValidator>
                            </EditItemTemplate>
                            <ItemTemplate>
                                <asp:Label ID="Label3" runat="server" Text='<%# Bind("publishDate", "{0:yyyy年MM月dd日}") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField ShowHeader="False">
                            <EditItemTemplate>
                                <asp:Button ID="Button1" runat="server" CausesValidation="True" CommandName="Update"
                                    Text="更新" ValidationGroup="grid" />&nbsp;<asp:Button ID="Button2" runat="server"
                                        CausesValidation="False" CommandName="Cancel" Text="キャンセル" />
                            </EditItemTemplate>
                            <ItemTemplate>
                                <asp:Button ID="Button1" runat="server" CausesValidation="False" CommandName="Edit"
                                    Text="編集" />&nbsp;<asp:Button ID="Button2" runat="server" CausesValidation="False"
                                        CommandName="Delete" OnClientClick="return confirm('本当に削除しても良いですか？')" Text="削除" />
                                <asp:Button ID="Button3" runat="server" CommandName="Select" Text="選択" />
                            </ItemTemplate>
                        </asp:TemplateField>
                    </Columns>
                    <RowStyle BackColor="#E3EAEB" />
                    <EditRowStyle BackColor="#7C6F57" />
                    <SelectedRowStyle BackColor="#C5BBAF" Font-Bold="True" ForeColor="#333333" />
                    <PagerStyle BackColor="#666666" ForeColor="White" HorizontalAlign="Center" />
                    <HeaderStyle BackColor="#1C5E55" Font-Bold="True" ForeColor="White" />
                    <AlternatingRowStyle BackColor="White" />
                </asp:GridView>
                <asp:SqlDataSource ID="sds" runat="server" ConflictDetection="CompareAllValues"
                    ConnectionString="<%$ ConnectionStrings:myDb %>" DeleteCommand="DELETE FROM [books] WHERE [isbn] = @original_isbn AND [title] = @original_title AND [publish] = @original_publish AND [price] = @original_price AND [publishDate] = @original_publishDate"
                    InsertCommand="INSERT INTO [books] ([isbn], [title], [publish], [price], [publishDate]) VALUES (@isbn, @title, @publish, @price, @publishDate)"
                    OldValuesParameterFormatString="original_{0}" SelectCommand="SELECT [isbn], [title], [publish], [price], [publishDate] FROM [books]"
                    UpdateCommand="UPDATE [books] SET [title] = @title, [publish] = @publish, [price] = @price, [publishDate] = @publishDate WHERE [isbn] = @original_isbn AND [title] = @original_title AND [publish] = @original_publish AND [price] = @original_price AND [publishDate] = @original_publishDate">
                    <DeleteParameters>
                        <asp:Parameter Name="original_isbn" Type="String" />
                        <asp:Parameter Name="original_title" Type="String" />
                        <asp:Parameter Name="original_publish" Type="String" />
                        <asp:Parameter Name="original_price" Type="Int32" />
                        <asp:Parameter Name="original_publishDate" Type="DateTime" />
                    </DeleteParameters>
                    <UpdateParameters>
                        <asp:Parameter Name="title" Type="String" />
                        <asp:Parameter Name="publish" Type="String" />
                        <asp:Parameter Name="price" Type="Int32" />
                        <asp:Parameter Name="publishDate" Type="DateTime" />
                        <asp:Parameter Name="original_isbn" Type="String" />
                        <asp:Parameter Name="original_title" Type="String" />
                        <asp:Parameter Name="original_publish" Type="String" />
                        <asp:Parameter Name="original_price" Type="Int32" />
                        <asp:Parameter Name="original_publishDate" Type="DateTime" />
                    </UpdateParameters>
                    <InsertParameters>
                        <asp:Parameter Name="isbn" Type="String" />
                        <asp:Parameter Name="title" Type="String" />
                        <asp:Parameter Name="publish" Type="String" />
                        <asp:Parameter Name="price" Type="Int32" />
                        <asp:Parameter Name="publishDate" Type="DateTime" />
                    </InsertParameters>
                </asp:SqlDataSource>
                <asp:ValidationSummary ID="validSummary" runat="server" ShowMessageBox="True" ShowSummary="False"
                    ValidationGroup="grid" />
            </asp:View>
            <asp:View ID="v2" runat="server">
                <asp:DetailsView ID="dv" runat="server" AutoGenerateRows="False" CellPadding="4"
                    DataKeyNames="name" DataSourceID="sds_d" ForeColor="#333333" GridLines="None"
                    Height="50px">
                    <FooterStyle BackColor="#1C5E55" Font-Bold="True" ForeColor="White" />
                    <CommandRowStyle BackColor="#C5BBAF" Font-Bold="True" />
                    <EditRowStyle BackColor="#7C6F57" />
                    <RowStyle BackColor="#E3EAEB" />
                    <PagerStyle BackColor="#666666" ForeColor="White" HorizontalAlign="Center" />
                    <Fields>
                        <asp:BoundField DataField="name" HeaderText="name" ReadOnly="True" SortExpression="name" />
                        <asp:BoundField DataField="postnum" HeaderText="postnum" SortExpression="postnum" />
                        <asp:BoundField DataField="address" HeaderText="address" SortExpression="address" />
                    </Fields>
                    <FieldHeaderStyle BackColor="#D0D0D0" Font-Bold="True" />
                    <HeaderStyle BackColor="#1C5E55" Font-Bold="True" ForeColor="White" />
                    <AlternatingRowStyle BackColor="White" />
                </asp:DetailsView>
                <asp:SqlDataSource ID="sds_d" runat="server" ConnectionString="<%$ ConnectionStrings:myDb %>"
                    SelectCommand="SELECT [name], [postnum], [address] FROM [publish] WHERE ([name] = @name)">
                    <SelectParameters>
                        <asp:Parameter Name="name" Type="String" />
                    </SelectParameters>
                </asp:SqlDataSource>
                <asp:Button ID="btnReturn" runat="server" CommandName="PrevView" Text="一覧へ戻る" /></asp:View>
        </asp:MultiView>&nbsp;</div>
    </form>
</body>
</html>
